#include <Windows.h>
#include <ShellApi.h>
#include <hbapi.h>
#include <fwh.h>
#include <ole2.h>
#include <shlobj.h>

#ifdef UNICODE
   DECLARE_HANDLE(HDROP);
#endif

#ifndef MSGFLT_ADD
   #define MSGFLT_ADD 1
#endif

BOOL FW_GetUnicode( void );

//----------------------------------------------------------------------------//

HB_FUNC( DRAGACCEPTFILES ) // ( hWnd, lOnOff )  --> nil
{
   #ifndef _WIN64
      DragAcceptFiles( ( HWND ) hb_parnl( 1 ), hb_parl( 2 ) );
   #else
      ChangeWindowMessageFilter( WM_DROPFILES, MSGFLT_ADD );
      ChangeWindowMessageFilter( WM_COPYDATA, MSGFLT_ADD );
      ChangeWindowMessageFilter( 0x0049, MSGFLT_ADD );

      DragAcceptFiles( ( HWND ) hb_parnll( 1 ), hb_parl( 2 ) );
   #endif
}

//----------------------------------------------------------------------------//

HB_FUNC( DRAGFINISH ) //  hDrop  --> nil
{
   // Windows has already freed the handle !!!
   // DragFinish( ( HDROP ) hb_parni( 1 ) );
}

//----------------------------------------------------------------------------//
/*
HB_FUNC( DRAGQUERYFILES ) // ( hDrop )  -->  aFiles
{
   #ifndef _WIN64
      HDROP hDrop = ( HDROP ) hb_parnl( 1 );
   #else
      HDROP hDrop = ( HDROP ) hb_parnll( 1 );
   #endif

   WORD wFiles = DragQueryFile( hDrop, 0xFFFFFFFF, NULL, 0 );
   WORD w;
   BYTE bBuffer[ 250 ];

   if( wFiles == 0 )
      MessageBox( 0, "zero files", "ok", 0 );

   hb_reta( wFiles );

   for( w = 0; w < wFiles; w++ )
   {
      DragQueryFile( hDrop, w, ( char * ) bBuffer, 249 );
      hb_storvc( ( char * ) bBuffer, -1, w + 1 );
   }
}
*/
//----------------------------------------------------------------------------//

HB_FUNC( DRAGQUERYFILES ) // ( hDrop )  -->  aFiles
{
   HDROP hDrop = ( HDROP ) fw_parH( 1 );
   WORD wFiles = DragQueryFile( hDrop, 0xFFFFFFFF, NULL, 0 );
   WORD w;
   BYTE bBuffer[ 2050 ];

   if( wFiles == 0 )
      MessageBox( 0, "zero files", "ok", 0 );

   hb_reta( wFiles );

	if ( FW_GetUnicode() )
	{
      for( w = 0; w < wFiles; w++ )
      {
         int  iLen;
      	LPSTR pFileName;

         iLen = DragQueryFileW( hDrop, w, ( LPWSTR ) bBuffer, 2048 );
         pFileName = UTF16toSTR8( ( LPWSTR ) bBuffer, iLen );
         hb_storvc( ( char * ) pFileName, -1, w + 1 );
         hb_xfree( ( void * ) pFileName );
      }
	}
	else
	{
      for( w = 0; w < wFiles; w++ )
      {
         DragQueryFileA( hDrop, w, ( char * ) bBuffer, 249 );
         hb_storvc( ( char * ) bBuffer, -1, w + 1 );
      }
	}
}

//----------------------------------------------------------------------------//

HB_FUNC( DRAGQUERYPOINT ) // ( hDrop, aPoint ) --> lInClient
{
   POINT pt;

   #ifndef _WIN64
      hb_retl( DragQueryPoint( ( HDROP ) hb_parnl( 1 ), &pt ) );
   #else
      hb_retl( DragQueryPoint( ( HDROP ) hb_parnll( 1 ), &pt ) );
   #endif

   hb_storvni( pt.x, 2, 1 );
   hb_storvni( pt.y, 2, 2 );
}

//----------------------------------------------------------------------------//

typedef struct {
    IDropTargetVtbl *lpVtbl;
    ULONG refCount;
    HWND hwnd;
} DropTarget;

HRESULT STDMETHODCALLTYPE DropTarget_QueryInterface(IDropTarget *This, REFIID riid, void **ppvObject);
ULONG STDMETHODCALLTYPE   DropTarget_AddRef(IDropTarget *This);
ULONG STDMETHODCALLTYPE   DropTarget_Release(IDropTarget *This);
HRESULT STDMETHODCALLTYPE DropTarget_DragEnter(IDropTarget *This, IDataObject *pDataObj, DWORD grfKeyState, POINTL pt, DWORD *pdwEffect);
HRESULT STDMETHODCALLTYPE DropTarget_DragOver(IDropTarget *This, DWORD grfKeyState, POINTL pt, DWORD *pdwEffect);
HRESULT STDMETHODCALLTYPE DropTarget_DragLeave(IDropTarget *This);
HRESULT STDMETHODCALLTYPE DropTarget_Drop(IDropTarget *This, IDataObject *pDataObj, DWORD grfKeyState, POINTL pt, DWORD *pdwEffect);

IDropTargetVtbl DropTarget_Vtbl = {
    DropTarget_QueryInterface,
    DropTarget_AddRef,
    DropTarget_Release,
    DropTarget_DragEnter,
    DropTarget_DragOver,
    DropTarget_DragLeave,
    DropTarget_Drop
};

HRESULT STDMETHODCALLTYPE DropTarget_QueryInterface(IDropTarget *This, REFIID riid, void **ppvObject) {
    if (IsEqualIID(riid, &IID_IUnknown) || IsEqualIID(riid, &IID_IDropTarget)) {
        *ppvObject = This;
        This->lpVtbl->AddRef(This);
        return S_OK;
    }
    *ppvObject = NULL;
    return E_NOINTERFACE;
}

ULONG STDMETHODCALLTYPE DropTarget_AddRef(IDropTarget *This) {
    DropTarget *pThis = (DropTarget *)This;
    return InterlockedIncrement(&pThis->refCount);
}

ULONG STDMETHODCALLTYPE DropTarget_Release(IDropTarget *This) {
    DropTarget *pThis = (DropTarget *)This;
    ULONG refCount = InterlockedDecrement(&pThis->refCount);
    if (refCount == 0) {
        hb_xfree( pThis );
    }
    return refCount;
}

HRESULT STDMETHODCALLTYPE DropTarget_DragEnter(IDropTarget *This, IDataObject *pDataObj, DWORD grfKeyState, POINTL pt, DWORD *pdwEffect) {
    *pdwEffect = DROPEFFECT_COPY;
    return S_OK;
}

HRESULT STDMETHODCALLTYPE DropTarget_DragOver(IDropTarget *This, DWORD grfKeyState, POINTL pt, DWORD *pdwEffect) {
    *pdwEffect = DROPEFFECT_COPY;
    return S_OK;
}

HRESULT STDMETHODCALLTYPE DropTarget_DragLeave(IDropTarget *This) {
    return S_OK;
}

typedef struct {
  DWORD dwSize;
  POINT pt;
  BOOL  fNC;
  BOOL  fWide;
  char  filename[ 1000 ];
} FW_DROPFILES;

static void lMsg( LONG lValue )
{
   char szBuffer[ 320 ];

   wsprintf( szBuffer, "%ld", lValue );
   MessageBox( NULL, szBuffer, "lMsg", MB_TASKMODAL );
}

HRESULT STDMETHODCALLTYPE DropTarget_Drop(IDropTarget *This, IDataObject *pDataObj, DWORD grfKeyState, POINTL pt, DWORD *pdwEffect) {

    FORMATETC fmtetc = {CF_TEXT, 0, DVASPECT_CONTENT, -1, TYMED_HGLOBAL};
    STGMEDIUM stgmed;
    HGLOBAL hMem;
    FW_DROPFILES * df;
    
   if (pDataObj->lpVtbl->QueryGetData(pDataObj, &fmtetc) == S_OK) {
       if (pDataObj->lpVtbl->GetData(pDataObj, &fmtetc, &stgmed) == S_OK) {
         #ifdef __BORLANDC__
            HDROP hDrop = ( HDROP ) GlobalLock( stgmed.u.hGlobal );
         #else   
            HDROP hDrop = ( HDROP ) GlobalLock( stgmed.hGlobal );
         #endif   
         hMem = GlobalAlloc( GHND, sizeof( FW_DROPFILES ) );
         df = GlobalLock( hMem );
         df->dwSize = ( INT_PTR ) df->filename - ( INT_PTR ) df;
         df->pt.x = pt.x;
         df->pt.y = pt.y;
         df->fNC = FALSE;
         df->fWide = FALSE;
         lstrcpyn( df->filename, ( char * ) hDrop, 1000 );
         GlobalUnlock( hMem ); 
         SendMessage( ( ( DropTarget * ) This )->hwnd, WM_DROPFILES, ( WPARAM ) hMem, 0 );
         #ifdef __BORLANDC__
            GlobalUnlock( stgmed.u.hGlobal );
         #else   
            GlobalUnlock( stgmed.hGlobal );
         #endif   
         ReleaseStgMedium(&stgmed);
      }
   }  

   GlobalFree( hMem );

   return S_OK;
}

//----------------------------------------------------------------------------//

HB_FUNC( REGISTERDRAGDROP )
{
   DropTarget * pDropTarget = ( DropTarget * ) hb_xgrab( sizeof( DropTarget ) );
   HWND hWnd = fw_parH( 1 );

   pDropTarget->lpVtbl = &DropTarget_Vtbl;
   pDropTarget->refCount = 1;
   pDropTarget->hwnd = hWnd;
   
   OleInitialize( NULL );

   RegisterDragDrop( hWnd, ( IDropTarget * ) pDropTarget );  
   hb_retptr( pDropTarget ); 
}

//----------------------------------------------------------------------------//

HB_FUNC( REVOKEDRAGDROP )
{
   RevokeDragDrop( fw_parH( 1 ) );
   OleUninitialize();
}

//----------------------------------------------------------------------------//